    001/*
    002 * Copyright (c) 2016-2017 Chris K Wensel <chris@wensel.net>. All Rights Reserved.
    003 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    004 *
    005 * Project and contact information: http://www.cascading.org/
    006 *
    007 * This file is part of the Cascading project.
    008 *
    009 * Licensed under the Apache License, Version 2.0 (the "License");
    010 * you may not use this file except in compliance with the License.
    011 * You may obtain a copy of the License at
    012 *
    013 *     http://www.apache.org/licenses/LICENSE-2.0
    014 *
    015 * Unless required by applicable law or agreed to in writing, software
    016 * distributed under the License is distributed on an "AS IS" BASIS,
    017 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    018 * See the License for the specific language governing permissions and
    019 * limitations under the License.
    020 */
    021
    022package cascading.operation;
    023
    024import cascading.tuple.Fields;
    025
    026public interface OperationCall<Context>
    027  {
    028  /**
    029   * Returns the user set context object, C.
    030   *
    031   * @return user defined object
    032   */
    033  Context getContext();
    034
    035  /**
    036   * Sets the user defined 'context' object.
    037   *
    038   * @param context user defined object
    039   */
    040  void setContext( Context context );
    041
    042  /**
    043   * Returns the {@link Fields} of the expected arguments {@link cascading.tuple.TupleEntry}.
    044   *
    045   * @return the argumentFields (type Fields) of this OperationCall object.
    046   */
    047  Fields getArgumentFields();
    048
    049  /**
    050   * Returns the {@link Fields} declared by this operation.
    051   * <p>
    052   * If the original declared fields on the current operation defined a substitution, this value
    053   * will be the actual resolved fields. That is, if the current operation declared {@link Fields#ARGS}
    054   * this method will return the declared arguments on the operator pipe.
    055   *
    056   * @return the declaredFields (type Fields) of this OperationCall object.
    057   */
    058  Fields getDeclaredFields();
    059  }